//======================================================================
// Header file
//
// Written for the book Programming Windows CE
// Copyright (C) 2003 Douglas Boling
//======================================================================
// Returns number of elements
#define dim(x) (sizeof(x) / sizeof(x[0]))

//----------------------------------------------------------------------
// Generic defines and data types
//
struct decodeUINT {                             // Structure associates
    UINT Code;                                  // messages
                                                // with a function.
    LRESULT (*Fxn)(HWND, UINT, WPARAM, LPARAM);
}; 
struct decodeCMD {                              // Structure associates
    UINT Code;                                  // menu IDs with a
    LRESULT (*Fxn)(HWND, WORD, HWND, WORD);     // function.
};

typedef struct _KeyBox
{
	RECT DrawPos;
	POINT BoxPos;
}KeyBox;
//----------------------------------------------------------------------
// Function prototypes
//
HWND InitInstance (HINSTANCE, LPWSTR, int);
int TermInstance (HINSTANCE, int);
// Window procedures
LRESULT CALLBACK MainWndProc (HWND, UINT, WPARAM, LPARAM);
// Message handlers
LRESULT DoPaintMain (HWND, UINT, WPARAM, LPARAM);
LRESULT DoSizeMain (HWND, UINT, WPARAM, LPARAM);
LRESULT DoDestroyMain (HWND, UINT, WPARAM, LPARAM);
LRESULT DoCTLCOLORMain (HWND, UINT, WPARAM, LPARAM);
LRESULT DoCreateMain (HWND, UINT, WPARAM, LPARAM);
LRESULT DoCommandMain (HWND hWnd, UINT wMsg, WPARAM wParam,LPARAM lParam);
LRESULT DoKeyDownMain(HWND hWnd, UINT wMsg, WPARAM wParam,LPARAM lParam);
LRESULT DoCharMain(HWND hWnd, UINT wMsg, WPARAM wParam,LPARAM lParam);
LRESULT DoTimerMain(HWND hWnd, UINT wMsg, WPARAM wParam,LPARAM lParam);
LRESULT DoLButtonMain(HWND hWnd, UINT wMsg, WPARAM wParam,LPARAM lParam);
BOOL Check(TCHAR chr);
void Rookie_Func(void);
BOOL Success(HWND hWnd);
RECT SetBoxRect(RECT rect);
SYSTEMTIME GetUseTime(unsigned long time_value);
#define SET_REC(x)	x.left,x.top,x.right,x.bottom
#define BoardCnt	9
#define GCnt	9
#define RookieColor RGB(100,100,255)
