
#include <windows.h>                 
#include <commctrl.h>     
#include <time.h>
#include "MyHead.h"                

const TCHAR szAppName[] = TEXT ("SDOCU");
HINSTANCE hInst;                    
RECT Board;
KeyBox Box;
int Delta;
BOOL Rookie = FALSE;
HPEN MyPen,OldPen,RedPen,RookPen;
char RookArray[BoardCnt];
int GameCnt;
BOOL NewStage = FALSE;
unsigned long UseTime;
BOOL	Sound = TRUE;
char Num[GCnt][BoardCnt][BoardCnt] = {
	{	
		{8,0,3,0,0,0,0,0,4},//1111111111111111
		{0,5,2,0,0,0,7,0,0},
		{0,0,6,0,1,8,9,0,3},
		{0,0,9,0,0,2,0,8,0},
		{0,0,0,0,3,0,0,0,0},
		{0,7,0,8,0,0,4,0,0},
		{9,0,8,6,2,0,5,0,0},
		{0,0,1,0,0,0,8,3,0},
		{4,0,0,0,0,0,1,0,6}
	},
	{
		{0,0,4,7,0,0,0,0,1},//22222222222222222
		{6,0,1,0,0,0,5,8,0},
		{0,0,0,0,9,5,3,0,0},
		{0,6,0,0,4,0,0,1,0},
		{4,0,8,0,0,0,7,0,2},
		{0,1,0,0,5,0,0,9,0},
		{0,0,6,5,1,0,0,0,0},
		{0,8,9,0,0,0,2,0,3},
		{7,0,0,0,0,2,1,0,0}
	},
	{
		{0,0,0,3,6,0,7,0,0},//3333333333333333333
		{0,8,0,0,0,0,0,2,0},
		{0,0,0,9,0,7,0,0,1},
		{0,0,0,0,3,0,1,0,0},
		{0,3,6,0,0,0,4,8,0},
		{0,0,5,0,7,0,0,0,0},
		{7,0,0,2,0,9,0,0,0},
		{0,5,0,0,0,0,0,6,0},
		{0,0,2,0,4,6,0,0,0}
	},
	{
		{2,0,0,0,0,0,0,0,0},//4444444444444444444444
		{0,9,0,8,0,0,0,5,6},
		{0,0,7,3,0,0,0,1,9},
		{0,0,0,4,3,0,0,8,0},
		{0,0,0,0,0,0,0,0,0},
		{0,4,0,0,5,9,0,0,0},
		{7,2,0,0,0,1,3,0,0},
		{1,8,0,0,0,5,0,7,0},
		{0,0,0,0,0,0,0,0,5}
	},
	{
		{0,7,0,4,3,0,0,8,0},//55555555555555555555
		{0,0,4,9,0,0,1,0,0},
		{5,3,0,0,0,7,0,2,4},
		{0,5,9,6,0,0,4,0,0},
		{0,8,0,7,0,0,0,5,0},
		{0,0,6,5,0,1,8,3,0},
		{6,2,0,8,0,0,0,4,5},
		{0,0,5,0,0,6,3,0,0},
		{0,9,0,0,5,4,0,6,0}
	},	
	{
		{0,1,0,0,0,5,9,0,0},//66666666666666666
		{0,0,7,2,0,0,1,3,0},
		{0,0,3,0,0,8,0,0,4},
		{0,8,0,0,7,4,0,6,0},
		{0,0,9,0,2,0,8,0,0},
		{0,7,0,0,0,3,0,5,0},
		{5,0,0,6,0,0,3,0,0},
		{0,6,4,0,0,1,7,0,0},
		{0,0,1,8,0,0,0,9,0}
	},
	{
		{0,0,3,8,1,0,0,0,9},//77777777777777777777
		{5,0,0,4,0,0,0,8,0},
		{0,6,0,9,0,0,1,0,0},
		{0,0,8,0,3,0,0,0,6},
		{0,0,0,0,0,0,0,0,0},
		{9,0,0,6,0,0,5,0,0},
		{0,0,6,0,0,9,0,1,0},
		{0,1,0,0,0,5,0,0,4},
		{2,0,0,0,4,8,7,0,0}
	},
	{
		{2,0,0,0,0,3,0,5,0},//8888888888888888
		{4,0,0,0,8,0,6,0,0},
		{0,3,0,0,0,0,0,0,0},
		{0,0,7,5,0,0,0,0,6},
		{3,0,0,0,0,0,0,0,7},
		{9,0,0,0,0,2,4,0,0},
		{0,0,0,0,0,0,0,3,0},
		{0,0,1,0,6,0,0,0,9},
		{0,7,0,8,0,0,0,0,1}
	},
	{
		{5,0,0,0,0,8,0,0,1},//9999999999999999
		{9,0,0,0,4,0,3,0,8},
		{0,8,2,1,6,0,9,0,0},
		{0,4,0,0,1,5,0,6,0},
		{0,6,3,0,0,4,7,9,0},
		{0,5,0,0,0,7,0,4,0},
		{0,0,8,0,2,6,5,1,0},
		{6,0,5,0,7,0,0,0,9},
		{3,0,0,4,0,0,0,0,6}
	}

};
char conNum[BoardCnt][BoardCnt];
const struct decodeUINT MainMessages[] = {  
    WM_PAINT, DoPaintMain,    
    WM_DESTROY, DoDestroyMain,	
	WM_SIZE,DoSizeMain,	
	WM_COMMAND,DoCommandMain,
	WM_CREATE,DoCreateMain,
	WM_CTLCOLORSTATIC,DoCTLCOLORMain,
	WM_KEYDOWN,DoKeyDownMain,
	WM_LBUTTONDOWN,DoLButtonMain,
	WM_CHAR,DoCharMain,
	WM_TIMER,DoTimerMain
};


 int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    LPWSTR lpCmdLine, int nCmdShow) {
    MSG msg;
    HWND hwndMain;
  
   
    hwndMain = InitInstance (hInstance, lpCmdLine, nCmdShow);
    if (hwndMain == 0)
        return 0x10;
        
    while (GetMessage (&msg, NULL, 0, 0)) {
        TranslateMessage (&msg);
        DispatchMessage (&msg);
    }

   
    return TermInstance (hInstance, msg.wParam);
}

HWND InitInstance (HINSTANCE hInstance, LPWSTR lpCmdLine, int nCmdShow) {
    WNDCLASS wc;
    HWND hWnd;

#if defined(WIN32_PLATFORM_PSPC)
    // If Pocket PC, allow only one instance of the application
    hWnd = FindWindow (szAppName, NULL);
    if (hWnd) {
        SetForegroundWindow ((HWND)(((DWORD)hWnd) | 0x01));    
        return 0;
    }
#endif
	
    hInst = hInstance;  // Save program instance handle

    // Register application main window class.
    wc.style = 0;                             // Window style
    wc.lpfnWndProc = MainWndProc;             // Callback function
    wc.cbClsExtra = 0;                        // Extra class data
    wc.cbWndExtra = 0;                        // Extra window data
    wc.hInstance = hInstance;                 // Owner handle
    wc.hIcon = NULL ,                       // Application icon
    wc.hCursor = LoadCursor (NULL, IDC_ARROW);// Default cursor
    wc.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH);
    wc.lpszMenuName =  NULL;                  // Menu name
    wc.lpszClassName = szAppName;             // Window class name

    if (RegisterClass(&wc) == 0) return 0;
    
    // Create main window.
    hWnd = CreateWindowEx (WS_EX_NODRAG, szAppName, TEXT ("KeyTrac"),
                      WS_VISIBLE | WS_CAPTION | WS_SYSMENU |WS_THICKFRAME,
                         CW_USEDEFAULT, CW_USEDEFAULT, 
                         CW_USEDEFAULT, CW_USEDEFAULT, 
                         NULL, NULL, hInstance, NULL);         
        
    // Fail if window not created
    if (!IsWindow (hWnd)) return 0; 

    // Standard show and update calls
    ShowWindow (hWnd, nCmdShow);
    UpdateWindow (hWnd);
    return hWnd;
}

int TermInstance (HINSTANCE hInstance, int nDefRC)
{
	return nDefRC;
}

LRESULT CALLBACK MainWndProc (HWND hWnd, UINT wMsg, WPARAM wParam,LPARAM lParam)
{
    INT i;
    
    for (i = 0; i < dim(MainMessages); i++) {
        if (wMsg == MainMessages[i].Code)
            return (*MainMessages[i].Fxn)(hWnd, wMsg, wParam, lParam);
    }
    return DefWindowProc (hWnd, wMsg, wParam, lParam);
}
LRESULT DoCharMain(HWND hWnd, UINT wMsg, WPARAM wParam,LPARAM lParam)
{
	RECT rect;
	SYSTEMTIME Time_value;
	TCHAR chr[256];
	if (((TCHAR)wParam > '0') && ((TCHAR)wParam <= '9' ))
	{
		if (!conNum[Box.BoxPos.y][Box.BoxPos.x])
		{
			if (Check((TCHAR)wParam))
			{
				Num[GameCnt][Box.BoxPos.y][Box.BoxPos.x] = (TCHAR)wParam - '0';
				rect = SetBoxRect(Box.DrawPos);
				InvalidateRect(hWnd,&rect,TRUE);
				if(Success(hWnd))
				{			
					Time_value = GetUseTime(UseTime);

					if (Time_value.wHour)
					{
						wsprintf(chr,TEXT("Success !! \n Time : %d Hour  %d Min  %d sec \n Next Stage ?"),Time_value.wHour,Time_value.wMinute,Time_value.wSecond);
					}
					else	
					{
						wsprintf(chr,TEXT("Success !! \n Time : %d Min  %d sec \n Next Stage ?"),Time_value.wMinute,Time_value.wSecond);
					}
					if(MessageBox(hWnd,chr,TEXT("Success"),MB_YESNO)==IDYES)
					{						
						memcpy(&Num[GameCnt],conNum,sizeof(conNum));
						if (GameCnt == GCnt-1)
						{
							if(MessageBox(hWnd,TEXT("End Stage... 1st Stage Again? "),TEXT("Stage Move"),MB_YESNO)==IDYES)
							{
								GameCnt = 0;					
							}
							else
							{
								DestroyWindow(hWnd);
							}
						}
						else
						{
							++GameCnt;
						}		
						NewStage = TRUE;			
						memcpy(conNum,&Num[GameCnt],sizeof(Num[GameCnt]));
						InvalidateRect(hWnd,NULL,TRUE);
					}
					else
					{
						DestroyWindow(hWnd);
					}		
				}
			}		
		}		
	}
	return 0;
}

LRESULT DoLButtonMain(HWND hWnd, UINT wMsg, WPARAM wParam,LPARAM lParam)
{
	RECT rect;
	if (((HIWORD(lParam) / Delta)*Delta >= Board.top) &&  ((LOWORD(lParam) / Delta)*Delta >=Board.left) && ((HIWORD(lParam) / Delta)*Delta < Board.bottom) && ((LOWORD(lParam) / Delta)*Delta < Board.right))
	{
		rect = SetBoxRect(Box.DrawPos);
		InvalidateRect(hWnd,&rect,TRUE);
		Box.DrawPos.top = (HIWORD(lParam) / Delta)*Delta;
		Box.DrawPos.left = (LOWORD(lParam) / Delta)*Delta;
		Box.DrawPos.right = Box.DrawPos.left + Delta;
		Box.DrawPos.bottom = Box.DrawPos.top + Delta;
		Box.BoxPos.x = ((LOWORD(lParam)-Delta) / Delta);
		Box.BoxPos.y = ((HIWORD(lParam)-Delta) / Delta);
		if(Sound)
		{
			MessageBeep(MB_ICONEXCLAMATION);
		}		
		rect = SetBoxRect(Box.DrawPos);
		InvalidateRect(hWnd,&rect,TRUE);
		if (Rookie)
		{
			rect.left = Board.left;
			rect.right = Board.right+20;
			rect.top = Board.bottom;
			rect.bottom = Board.bottom+20;
			InvalidateRect(hWnd,&rect,TRUE);
		}
	}
	return 0;
}
RECT SetBoxRect(RECT rect)
{
	rect.bottom +=2;
	rect.left -=2;
	rect.right+=2;
	rect.top -=2;
	return rect;
}
LRESULT DoKeyDownMain(HWND hWnd, UINT wMsg, WPARAM wParam,LPARAM lParam)
{
	RECT rect;
	switch(wParam)
	{
	case VK_UP:
		if (Box.BoxPos.y)
		{
			rect = SetBoxRect(Box.DrawPos);
			InvalidateRect(hWnd,&rect,TRUE);
			Box.DrawPos.top -= Delta; 
			Box.DrawPos.bottom -= Delta;
			Box.BoxPos.y -= 1;			
			rect = SetBoxRect(Box.DrawPos);
			InvalidateRect(hWnd,&rect,TRUE);
		}
		if(Sound)
		{
			MessageBeep(MB_ICONEXCLAMATION);
		}
		break;
	case VK_DOWN:
		if (Box.BoxPos.y!=8)
		{
			rect = SetBoxRect(Box.DrawPos);
			InvalidateRect(hWnd,&rect,TRUE);
			Box.DrawPos.top += Delta; 
			Box.DrawPos.bottom += Delta;
			Box.BoxPos.y += 1;
			rect = SetBoxRect(Box.DrawPos);
			InvalidateRect(hWnd,&rect,TRUE);
		}
		if(Sound)
		{
			MessageBeep(MB_ICONEXCLAMATION);
		}
		break;
	case VK_LEFT:
		if (Box.BoxPos.x)
		{
			rect = SetBoxRect(Box.DrawPos);
			InvalidateRect(hWnd,&rect,TRUE);
			Box.DrawPos.left -= Delta; 
			Box.DrawPos.right -= Delta;
			Box.BoxPos.x -= 1;
			rect = SetBoxRect(Box.DrawPos);
			InvalidateRect(hWnd,&rect,TRUE);
		}
		if(Sound)
		{
			MessageBeep(MB_ICONEXCLAMATION);
		}
		break;
	case VK_RIGHT:
		if (Box.BoxPos.x!=8)
		{
			rect = SetBoxRect(Box.DrawPos);
			InvalidateRect(hWnd,&rect,TRUE);
			Box.DrawPos.left += Delta; 
			Box.DrawPos.right += Delta;
			Box.BoxPos.x += 1;
			rect = SetBoxRect(Box.DrawPos);
			InvalidateRect(hWnd,&rect,TRUE);
		}
		if(Sound)
		{
			MessageBeep(MB_ICONEXCLAMATION);
		}
		break;
	case VK_DELETE:
		if (Num[GameCnt][Box.BoxPos.y][Box.BoxPos.x])
		{
			if (!conNum[Box.BoxPos.y][Box.BoxPos.x])
			{
				Num[GameCnt][Box.BoxPos.y][Box.BoxPos.x] = 0;
				rect = SetBoxRect(Box.DrawPos);
				InvalidateRect(hWnd,&rect,TRUE);
			}
		}
		if(Sound)
		{
			MessageBeep(MB_ICONEXCLAMATION);
		}
		break;
	case VK_PRIOR:
		if (GameCnt < GCnt-1)
		{
			if (MessageBox(hWnd,TEXT(" Next Stage ?"),TEXT("Move Stage"),MB_YESNO)==IDYES)
			{
				memcpy(&Num[GameCnt],conNum,sizeof(conNum));
				++GameCnt;
				memcpy(conNum,&Num[GameCnt],sizeof(Num[GameCnt]));
				NewStage = TRUE;				
				InvalidateRect(hWnd,NULL,TRUE);
			}			
		}
		break;
	case VK_NEXT:
		if (GameCnt > 0)
		{
			if (MessageBox(hWnd,TEXT(" Pre Stage ?"),TEXT("Move Stage"),MB_YESNO)==IDYES)
			{
				memcpy(&Num[GameCnt],conNum,sizeof(conNum));
				--GameCnt;
				memcpy(conNum,&Num[GameCnt],sizeof(Num[GameCnt]));
				NewStage = TRUE;				
				InvalidateRect(hWnd,NULL,TRUE);
			}			
		}
		break;
	case VK_SPACE:
		Rookie = !Rookie; 
		rect.left = Board.left;
		rect.right = Board.right+20;
		rect.top = Board.bottom;
		rect.bottom = Board.bottom+20;
		InvalidateRect(hWnd,&rect,TRUE);
		if(Sound)
		{
			MessageBeep(MB_ICONEXCLAMATION);
		}
		break;
	}
	
	if (Rookie)
	{
		rect.left = Board.left;
		rect.right = Board.right+20;
		rect.top = Board.bottom;
		rect.bottom = Board.bottom+20;
		InvalidateRect(hWnd,&rect,TRUE);
	}
	return 0;
}
LRESULT DoSizeMain(HWND hWnd, UINT wMsg, WPARAM wParam,LPARAM lParam)
{	
	int temp;
    GetClientRect(hWnd,&Board);
	Delta = (Board.right <= Board.bottom) ? Board.right:Board.bottom;
	temp = Delta/(BoardCnt+2);
	Delta -= temp*2;
	Delta /= BoardCnt;
	Board.top = Board.top +temp;
	Board.left = Board.left + temp;
	Board.right = Board.left + (Delta * BoardCnt);
	Board.bottom = Board.top + (Delta * BoardCnt);

	Box.DrawPos.left = Board.left * ( Box.BoxPos.x+1);
	Box.DrawPos.top = Board.top* ( Box.BoxPos.y+1);
	Box.DrawPos.right = Box.DrawPos.left+Delta;
	Box.DrawPos.bottom = Box.DrawPos.top+Delta;
    return 0;
}

LRESULT DoCTLCOLORMain (HWND hWnd, UINT wMsg, WPARAM wParam,LPARAM lParam)
{
	//HDC hdc;
	//HBRUSH brush;
	//SetBkColor((HDC)wParam,GetSysColor(COLOR_WINDOW));
	SetTextColor((HDC)wParam,RGB(255,0,0));
	
	return (LRESULT)CreateSolidBrush(RGB(255,255,255));
}


LRESULT DoCommandMain (HWND hWnd, UINT wMsg, WPARAM wParam,LPARAM lParam)
{	
	return 0;
}
LRESULT DoCreateMain (HWND hWnd, UINT wMsg, WPARAM wParam,LPARAM lParam)
{
	LOGPEN lp;	
	lp.lopnStyle = PS_SOLID;
	lp.lopnColor = RGB(0,0,0);
	lp.lopnWidth.x = 3;
	lp.lopnWidth.y = 3;
	MyPen = CreatePenIndirect(&lp);
	lp.lopnStyle = PS_SOLID;
	lp.lopnColor = RGB(255,0,0);
	lp.lopnWidth.x = 3;
	lp.lopnWidth.y = 3;
	RedPen = CreatePenIndirect(&lp);
	lp.lopnStyle = PS_SOLID;
	lp.lopnColor = RookieColor;
	lp.lopnWidth.x = 3;
	lp.lopnWidth.y = 3;
	RookPen = CreatePenIndirect(&lp);
	memcpy(conNum,&Num[GameCnt],sizeof(Num[GameCnt]));
	NewStage = TRUE;
	SetTimer(hWnd,100,1000,NULL);
	return 0;
}
LRESULT DoPaintMain (HWND hWnd, UINT wMsg, WPARAM wParam, 
                     LPARAM lParam) {
    PAINTSTRUCT ps; 
    HDC hdc;	
	POINT pt[2];
	int iCnt;
	int jCnt;
	TCHAR chr[256];
	RECT NumRec;
	//HBRUSH brush,Oldbrush;
	
	hdc = BeginPaint (hWnd, &ps);
	Rectangle(hdc,SET_REC(Board));
	pt[0].x = Board.left;
	pt[0].y = Board.top;
	pt[1].x = Board.left;
	pt[1].y = Board.bottom;
	for(iCnt=0;iCnt < BoardCnt-1 ;iCnt++)
	{	
		if (!((iCnt+1)%3))
		{
			OldPen = (HPEN)SelectObject(hdc,MyPen);
		}
		pt[0].x += Delta;
		pt[1].x += Delta;
		Polyline(hdc,pt,2);
		if (!((iCnt+1)%3))
		{
			SelectObject(hdc,OldPen);
		}
	}
	pt[0].x = Board.left;
	pt[0].y = Board.top;
	pt[1].x = Board.right;
	pt[1].y = Board.top;
	for(iCnt=0;iCnt < BoardCnt-1 ;iCnt++)
	{	
		if (!((iCnt+1)%3))
		{
			OldPen = (HPEN)SelectObject(hdc,MyPen);
		}
		pt[0].y += Delta;
		pt[1].y += Delta;
		Polyline(hdc,pt,2);	
		if (!((iCnt+1)%3))
		{
			SelectObject(hdc,OldPen);
		}
	}
	OldPen = (HPEN)SelectObject(hdc,RedPen);
	if (Rookie)
	{
		/*
		SelectObject(hdc,RookPen);
		brush = (HBRUSH)GetStockObject(NULL_BRUSH);
		Oldbrush = (HBRUSH)SelectObject(hdc,brush);

		NumRec.left = Box.DrawPos.left - (Box.BoxPos.x * Delta);
		NumRec.right = Box.DrawPos.right + ((BoardCnt-1 - Box.BoxPos.x)*Delta);
		NumRec.top = Box.DrawPos.top;
		NumRec.bottom = Box.DrawPos.bottom;
		Rectangle(hdc,SET_REC(NumRec));
		
		NumRec.left = Box.DrawPos.left;
		NumRec.right = Box.DrawPos.right;
		NumRec.top = Box.DrawPos.top - (Box.BoxPos.y * Delta);
		NumRec.bottom = Box.DrawPos.bottom + ((BoardCnt-1 - Box.BoxPos.y)*Delta);
		Rectangle(hdc,SET_REC(NumRec));
		*/
		if (!Num[GameCnt][Box.BoxPos.y][Box.BoxPos.x])
		{
			Rookie_Func();
			NumRec.left = Board.left;
			NumRec.right = NumRec.left+20;
			NumRec.top = Board.bottom;
			NumRec.bottom = NumRec.top+20;
			for (iCnt=0;iCnt<BoardCnt;iCnt++)
			{
				if(!RookArray[iCnt])
				{
					wsprintf(chr,TEXT("%d"),iCnt+1);
					DrawText(hdc,chr,lstrlen(chr),&NumRec,DT_SINGLELINE|DT_CENTER|DT_VCENTER);
					NumRec.left += 20;
					NumRec.right += 20;
				}
				
			}
			memset(RookArray,0,sizeof(RookArray));
		}
		SelectObject(hdc,RedPen);
		//SelectObject(hdc,Oldbrush);
		//DeleteObject(brush);
	}
	
	Rectangle(hdc,SET_REC(Box.DrawPos));
	
	NumRec.left = Board.left;
	NumRec.top = Board.top ;
	NumRec.bottom = NumRec.top + Delta;
	NumRec.right = NumRec.left + Delta;
	for (jCnt=0;jCnt<BoardCnt;jCnt++)
	{	
		
		for (iCnt=0;iCnt<BoardCnt;iCnt++)
		{
			if (Num[GameCnt][(NumRec.top - Delta)/Delta][(NumRec.left - Delta)/Delta])
			{
				wsprintf(chr,TEXT("%d"),Num[GameCnt][(NumRec.top - Delta)/Delta][(NumRec.left - Delta)/Delta]);
			}
			else
			{
				wsprintf(chr,TEXT(" "));
			}	
			DrawText(hdc,chr,lstrlen(chr),&NumRec,DT_SINGLELINE|DT_CENTER|DT_VCENTER);		
			NumRec.left += Delta;
			NumRec.right += Delta;
		}
		NumRec.left = Board.left;
		NumRec.right = NumRec.left + Delta;
		NumRec.top += Delta;
		NumRec.bottom += Delta;
	}	

	

	if (NewStage)
	{
			
		if(MessageBox(hWnd,TEXT(" START GAME "),TEXT("START"),MB_YESNO)==IDYES)
		{
			UseTime = 0;
			NewStage = FALSE;
		}
		else
		{
			DestroyWindow(hWnd);
		}
	}
	SelectObject(hdc,OldPen);
    EndPaint (hWnd, &ps);
    return 0;
}
LRESULT DoTimerMain (HWND hWnd, UINT wMsg, WPARAM wParam,LPARAM lParam) 
{
	++UseTime;	
	return 0;
}
LRESULT DoDestroyMain (HWND hWnd, UINT wMsg, WPARAM wParam,
                       LPARAM lParam) {
	KillTimer(hWnd,100);
	DeleteObject(MyPen);
	DeleteObject(RookPen);
	DeleteObject(RedPen);
    PostQuitMessage (0);
    return 0;
}

BOOL Check(TCHAR chr)
{
	int iCnt,jCnt;
	int x,y;
	for (iCnt=0;iCnt < BoardCnt ; iCnt++)
	{
		if(Num[GameCnt][Box.BoxPos.y][iCnt] == (chr-'0'))
		{
			return FALSE;
		}
	}
	for (iCnt=0;iCnt < BoardCnt ; iCnt++)
	{
		if(Num[GameCnt][iCnt][Box.BoxPos.x] == (chr-'0'))
		{
			return FALSE;
		}
	}
	x = (Box.BoxPos.x/3)*3;
	y = (Box.BoxPos.y/3)*3;	
	for (iCnt=0;iCnt< (BoardCnt/3);iCnt++)
	{
		for (jCnt=0;jCnt< (BoardCnt/3);jCnt++)
		{
			if(Num[GameCnt][y+iCnt][x+jCnt] == (chr-'0'))
			{
				return FALSE;
			}
		}
	}
	return TRUE;
}

void Rookie_Func(void)
{
	int iCnt,jCnt;
	int x,y;

	for (iCnt=0;iCnt < BoardCnt ; iCnt++)
	{
		if (Num[GameCnt][Box.BoxPos.y][iCnt])
		{
			RookArray[Num[GameCnt][Box.BoxPos.y][iCnt]-1] = 1;
		}
		
	}
	for (iCnt=0;iCnt < BoardCnt ; iCnt++)
	{		
		if (Num[GameCnt][iCnt][Box.BoxPos.x])
		{
			RookArray[Num[GameCnt][iCnt][Box.BoxPos.x]-1] = 1;
		}
	}
	x = (Box.BoxPos.x/3)*3; 
	y = (Box.BoxPos.y/3)*3;	
	for (iCnt=0;iCnt< (BoardCnt/3);iCnt++)
	{
		for (jCnt=0;jCnt< (BoardCnt/3);jCnt++)
		{			
			if (Num[GameCnt][y+iCnt][x+jCnt])
			{
	    		RookArray[Num[GameCnt][y+iCnt][x+jCnt]-1] = 1;
			}
		}
	}	
}
BOOL Success(HWND hWnd)
{
	int iCnt,jCnt;
	for (iCnt=0;iCnt<BoardCnt;iCnt++)
	{
		for (jCnt=0;jCnt<BoardCnt;jCnt++)
		{
			if(!Num[GameCnt][iCnt][jCnt])
			{
				return FALSE;
			}
		}
	}	
	return TRUE;
}

SYSTEMTIME GetUseTime(unsigned long time_value)
{
	SYSTEMTIME usetime;
	unsigned int temp;
	temp = time_value;
	usetime.wHour = temp/3600;
	temp = temp - (usetime.wHour * 3600);
	usetime.wMinute = temp/60;
	temp = temp - (usetime.wMinute * 60);
	usetime.wSecond = temp;
	return usetime;
}